Topologisches Datenskripten

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Topological data scripting and the translation is 100% complete.
Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文 • ‎中文(中国大陆)‎

Einführung

Hier erklären wir dir, wie du das Part Arbeitsbereich direkt aus dem FreeCAD Python Interpreter oder aus einem externen Skript heraus steuern kannst. Stelle sicher, dass du den Abschnitt Skripten und die Seiten FreeCAD Grundlagen Skripten durchblätterst, wenn du weitere Informationen über die Funktionsweise von Python Skripten in FreeCAD benötigst. Wenn du neu in Python bist, ist es eine gute Idee, zuerst den Abschnitt Einführung in Python zu lesen.

Siehe auch

Klassendiagramm

Dies ist ein Unified Modeling Language (UML) Überblick über die wesentlichen Klassen des Part Arbweitsbereichs:

Python Klassen des Part Arbeitsbereichs

Anfang

Geometrie

Die geometrischen Objekte sind die Bausteine aller topologischen Objekte:

  • Geom Basisklasse der geometrischen Objekte
  • Line Eine gerade Linie im Raum, definiert durch den Start- und Endpunkt
  • Circle Kreis oder Kreissegment definiert durch einen Mittelpunkt und einen Start- und Endpunkt
  • ...... Und demnächst mehr davon

Anfang

Topologie

The folgenden topologischen Datentypen stehen zur Verfügung:

  • Compound Eine Gruppe von beliebigen topologischen Objekten.
  • Compsolid Ein zusammengesetzter Körper (solid) ist ein Set von Körpern, die durch ihre Seiten verbunden sind. Dies erweitert das Konzept von WIRE and SHELL auf Körpern (solids).
  • Solid Ein Teil des Raumes, der durch eine geschlossene dreidimensionale Hülle begrenzt ist.
  • Shell Hülle = Ein Satz von über ihre Kanten verbundenen Flächen. Eine Hülle kann offen oder geschlossen sein.
  • Face Im zweidimensionalen ist es ein Teil einer Ebene; im dreidimensionalen ist es ein Teil einer Oberfläche. Die Form ist durch Konturen begrenzt (getrimmt). Auch im 3D gekrümmte Flächen haben sind Inneren zweidimensional parametriert.
  • Wire Ein Satz von über ihre Endpunkten verknüpften Kanten. Ein "Wire" kann eine offene oder geschlossene Form haben, je nach dem ob nicht verknüpfte Endpunkte vorhanden sind oder nicht.
  • Edge Ein topologisches Element (Kante) das mit einer beschränkten Kurve korrespondiert. Eine Kante ist generell durch Vertexe begrenzt. Eine Kante ist eindimensional.
  • Vertex Ein topologisches Element das mit einem Punkt korrespondiert. Es ist nulldimensional.
  • Shape Ein generischer Term für all die zuvor aufgezählten Elemente.

Anfang

Beispiel: Einfache Topologie erstellen

Wire

Wir werden nun eine Topologie erstellen, indem wir sie aus einer einfacheren Geometrie konstruieren. Als Fallstudie verwenden wir ein Teil, wie im Bild zu sehen, das aus vier Knoten, zwei Kreise und zwei Linien besteht.

Anfang

Geometrie erstellen

Zuerst erstellen wir die verschiedenen geometrischen Teile dieses Drahtes. Dabei stellen wir sicher, dass die Teile, die später verbunden werden die gleichen Knoten teilen.

Also erstellen wir zuerst die Punkte:

import Part
from FreeCAD import Base
V1 = Base.Vector(0, 10, 0)
V2 = Base.Vector(30, 10, 0)
V3 = Base.Vector(30, -10, 0)
V4 = Base.Vector(0, -10, 0)

Anfang

Bogen

Circle


Für jeden Bogen benötigen wir einen Hilfspunkt:

VC1 = Base.Vector(-10, 0, 0)
C1 = Part.Arc(V1, VC1, V4)
VC2 = Base.Vector(40, 0, 0)
C2 = Part.Arc(V2, VC2, V3)

Anfang

Linie

Line


Die Linienabschnitte können aus zwei Punkten erstellt werden:

L1 = Part.LineSegment(V1, V2)
L2 = Part.LineSegment(V3, V4)

Anfang

Alles zusammensetzen

Der letzte Schritt besteht darin, die geometrischen Basiselemente zusammenzusetzen und eine topologische Form zu backen:

S1 = Part.Shape([C1, L1, C2, L2])

Anfang

Ein Prisma herstellen

Jetzt extrudiere den Draht in eine Richtung und erzeugen eine tatsächliche 3D Form:

W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0, 0, 10))

Anfang

Alles anzeigen

Part.show(P)

Anfang

Erstellen von Grundformen

Du kannst ganz einfach topologische Grundobjekte mit den make...() Methoden aus dem Arbeitsbereich Part erstellen:

b = Part.makeBox(100, 100, 100)
Part.show(b)

Einige verfügbare make...() Methoden:

  • makeBox(l, w, h) Erstellt einen Quader, der sich in p befindet und in die Richtung d mit den Abmessungen (l,w,h) zeigt.
  • makeCircle(radius) Erstellt einen Kreis mit einem gegebenen Radius.
  • makeCone(radius1, radius2, height) Erstellt einen Kegel mit den gegebenen Radien und Höhen.
  • makeCylinder(radius, height) Erstellt einen Zylinder mit einem gegebenen Radius und Höhe.
  • makeLine((x1, y1, z1), (x2, y2, z2)) Erstellt eine Linie aus zwei Punkten.
  • makePlane(length, width) Erstellt eine Ebene mit Länge und Breite.
  • makePolygon(list) Erstellt ein Polygon aus einer Liste von Punkten.
  • makeSphere(radius) Erstellt eine Kugel mit einem bestimmten Radius.
  • makeTorus(radius1, radius2) Erstellt einen Torus mit den gegebenen Radien.

Siehe die Part API Seite für eine vollständige Liste der verfügbaren Methoden des Part Arbeitsbereichs.

Anfang

Module Importieren

Zuerst müssen wir den Part Arbeitsbereich importieren, damit wir seinen Inhalt in Python verwenden können. Wir werden auch das Basismodul aus dem FreeCAD Modul importieren:

import Part
from FreeCAD import Base

Anfang

Erstellen eines Vektors

Vektoren sind einer der am häufigsten verwendeten wichtigen Informationsteile beim Bau von Formen. Sie enthalten in der Regel drei Zahlen (aber nicht notwendigerweise immer): die kartesischen Koordinaten x, y und z. Du erstellst einen Vektor wie diesen:

myVector = Base.Vector(3, 2, 0)

Wir haben soeben einen Vektor mit den Koordinaten X = 3, Y = 2, Z = 0 erstellt. im Part Arbeitsbereich werden Vektoren überall verwendet. Part Formen verwenden auch eine andere Art von Punkt Darstellung namens Knoten, die einfach ein Behälter ist für einen Vektor. So greifst du auf den Vektor eines Knoten zu:

myVertex = myShape.Vertexes[0]
print myVertex.Point
> Vector (3, 2, 0)

Anfang

Erstellen einer Kante

Eine Kante ist nichts anderes als eine Linie mit zwei Knoten:

edge = Part.makeLine((0, 0, 0), (10, 0, 0))
edge.Vertexes
> [<Vertex object at 01877430>, <Vertex object at 014888E0>]

Hinweis: Du kannst auch eine Kante erzeugen, indem du zwei Vektoren übergibst:

vec1 = Base.Vector(0, 0, 0)
vec2 = Base.Vector(10, 0, 0)
line = Part.LineSegment(vec1, vec2)
edge = line.toShape()

Du kannst die Länge und den Mittelpunkt einer Kante wie diese finden:

edge.Length
> 10.0
edge.CenterOfMass
> Vector (5, 0, 0)

Anfang

Die Form auf den Bildschirm bringen

Bisher haben wir ein Kantenobjekt erstellt, das aber nirgendwo auf dem Bildschirm erscheint. Das liegt daran, dass die FreeCAD 3D Szene nur das anzeigt, was du ihm sagst, dass er anzeigen soll. Um das zu tun, verwenden wir folgende einfache Methode:

Part.show(edge)

Die Anzeigefunktion erzeugt ein Objekt in unserem FreeCAD Dokument und weist unsere "Kanten"form ihm zu. Verwende dies, wenn es an der Zeit ist, deine Erstellung auf dem Bildschirm anzuzeigen.

Anfang

Erstellen eines Drahts

Ein Draht ist eine Mehrkantenlinie und kann aus einer Liste von Kanten oder sogar einer Liste von Drähten erstellt werden:

edge1 = Part.makeLine((0, 0, 0), (10, 0, 0))
edge2 = Part.makeLine((10, 0, 0), (10, 10, 0))
wire1 = Part.Wire([edge1, edge2]) 
edge3 = Part.makeLine((10, 10, 0), (0, 10, 0))
edge4 = Part.makeLine((0, 10, 0), (0, 0, 0))
wire2 = Part.Wire([edge3, edge4])
wire3 = Part.Wire([wire1, wire2])
wire3.Edges
> [<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, <Edge object at 0190A788>]
Part.show(wire3)

Part.show(wire3) zeigt die 4 Kanten, die unseren Draht bilden. Sonstige nützliche Informationen können leicht abgerufen werden:

wire3.Length
> 40.0
wire3.CenterOfMass
> Vector (5, 5, 0)
wire3.isClosed()
> True
wire2.isClosed()
> False

Anfang

Erstellen einer Fläche

Nur Flächen, die aus geschlossenen Drähten erstellt wurden, sind gültig. In diesem Beispiel ist Draht3 ein geschlossener Draht, aber Draht2 ist kein geschlossener Draht (siehe oben).

face = Part.Face(wire3)
face.Area
> 99.99999999999999
face.CenterOfMass
> Vector (5, 5, 0)
face.Length
> 40.0
face.isValid()
> True
sface = Part.Face(wire2)
face.isValid()
> False

Nur Flächen haben eine Grundfläche, Drähte und Kanten haben keine.

Anfang

Erstellen eines Kreises

So einfach kann ein Kreis erstellt werden:

circle = Part.makeCircle(10)
circle.Curve
> Circle (Radius : 10, Position : (0, 0, 0), Direction : (0, 0, 1))

Wenn Du ihn an einer bestimmten Stelle und mit einer bestimmten Richtung erzeugen möchtest:

ccircle = Part.makeCircle(10, Base.Vector(10, 0, 0), Base.Vector(1, 0, 0))
ccircle.Curve
> Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))

ccircle wird im Abstand 10 vom x Ursprung erstellt und ist nach außen entlang der x Achse gerichtet. Hinweis: makeCircle() akzeptiert nur Base.Vector() für die Position und normale Parameter, keine Tupel. Du kannst auch einen Teil des Kreises durch Angabe eines Anfangs- und eines Endwinkels erstellen:

from math import pi
arc1 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)
arc2 = Part.makeCircle(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 180, 360)

Winkel sollten in Grad angegeben werden. Wenn Du Bogenmaß hast, wandelst Du sie einfach mit der Formel um: Template:Incode/de oder mit Hilfe des Python math Moduls:

import math
degrees = math.degrees(radians)

Anfang

Erstellen eines Bogens entlang von Punkten

Leider gibt es keine makeArc() Funktion, aber wir haben die Part.Arc() Funktion um einen Bogen durch drei Punkte zu erzeugen. Es erzeugt ein Bogenobjekt das den Startpunktes mit dem Endpunkt durch den Mittelpunkt verbindet. Die toShape() Funktion des Bogenobjekts muss aufgerufen werden, um ein Kantenobjekt zu erhalten, wie bei der Verwendung von Part.LineSegment anstelle von Part.makeLine.

arc = Part.Arc(Base.Vector(0, 0, 0), Base.Vector(0, 5, 0), Base.Vector(5, 5, 0))
arc
> <Arc object>
arc_edge = arc.toShape()
Part.show(arc_edge)

Arc() akzeptiert nur Base.Vector() für Punkte, aber nicht für Tupel. Du kannst auch Folgendes erhalten einen Bogen unter Verwendung eines Kreisausschnitts:

from math import pi
circle = Part.Circle(Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 10)
arc = Part.Arc(circle,0,pi)

Bögen sind gültige Kanten wie Linien, so dass sie auch in Drähten verwendet werden können.

Anfang

Erstellen eines Polygons

Ein Polygon ist einfach ein Draht mit mehreren geraden Kanten. Die makePolygon() Funktion nimmt eine Liste von Punkten und erstellt einen Draht durch diese Punkte:

lshape_wire = Part.makePolygon([Base.Vector(0, 5, 0), Base.Vector(0, 0, 0), Base.Vector(5, 0, 0)])

Anfang

Erstellen einer Bézier Kurve

Bézier Kurven werden verwendet, um sanfte Kurven mit einer Reihe von Polen (Punkten) und optionalen Gewichten zu modellieren. Die folgende Funktion erstellt eine Part.BezierCurve() aus einer Reihe von FreeCAD.Vector() Punkten. (Hinweis: Wenn du einen einzelnen Pol oder ein Gewicht "erhältst" und "einstellst", beginnen die Indizes bei 1, nicht bei 0.)

def makeBCurveEdge(Points):
   geomCurve = Part.BezierCurve()
   geomCurve.setPoles(Points)
   edge = Part.Edge(geomCurve)
   return(edge)

Anfang

Erstellen einer Ebene

Eine Ebene ist einfach eine flache rechteckige Fläche. Die Methode, mit der eine solche erstellt wird, ist makePlane(length,width,[start_pnt,dir_normal])'. Standardmäßig start_pnt = Vektor(0,0,0,0) und dir_normal = Vektor(0,0,1). Verwendung von dir_normal = Vector(0,0,0,1) erzeugt die Ebene, die in Richtung der positiven z Achse zeigt, während dir_normal = Vector(1,0,0,0) die Ebene erzeugt, die in Richtung der positiven x Achse zeigt:

plane = Part.makePlane(2, 2)
plane
> <Face object at 028AF990>
plane = Part.makePlane(2, 2, Base.Vector(3, 0, 0), Base.Vector(0, 1, 0))
plane.BoundBox
> BoundBox (3, 0, 0, 5, 0, 2)

BoundBox ist ein Quader, der die Ebene mit einer Diagonale beginnend bei (3,0,0,0) und endet bei (5,0,2) einschliesst. Hier ist die BoundBox Dicke entlang der y Achse Null, zumal unsere Form völlig flach ist.

Hinweis: makePlane() akzeptiert nur Base.Vector() für start_pnt und dir_normal, nicht aber Tupel.

Anfang

Erstellen einer Ellipse

Es gibt mehrere Möglichkeiten, eine Ellipse zu erstellen:

Part.Ellipse()

Erzeugt eine Ellipse mit Hauptradius 2 und Nebenradius 1 mit dem Mittelpunkt bei (0,0,0).

Part.Ellipse(Ellipse)

Erstellt eine Kopie der angegebenen Ellipse.

Part.Ellipse(S1, S2, Center)

Erzeugt eine Ellipse, die auf den Punkt Mitte zentriert ist, an dem die Ebene der Ellipse definiert ist durch Mittelpunkt, S1 und S2, ihre Hauptachse definiert ist durch Mittelpunkt und S1, sein Hauptradius ist der Abstand zwischen Mittelpunkt und S1, und sein kleiner Radius ist der Abstand zwischen S2 und der Hauptachse.

Part.Ellipse(Center, MajorRadius, MinorRadius)

Erstellt eine Ellipse mit Haupt- und Nebenradien Hauptradius und Nebenradius, die sich in der durch den Mittelpunkt definierten Ebene und der Normalen (0,0,1) befinden.

eli = Part.Ellipse(Base.Vector(10, 0, 0), Base.Vector(0, 5, 0), Base.Vector(0, 0, 0))
Part.show(eli.toShape())

Im obigen Code haben wir S1, S2 und Mitte überschritten. Ähnlich wie Arc, Ellipse erzeugt ein Ellipsenobjekt, aber keine Kante, also müssen wir es in eine Kante mit toShape() zur Anzeige konvertieren.

Hinweis: Ellipse() akzeptiert nur Base.Vector() für Punkte, nicht aber für Tupel.

eli = Part.Ellipse(Base.Vector(0, 0, 0), 10, 5)
Part.show(eli.toShape())

Für den obigen Ellipsenkonstruktor haben wir Mitte, HauptRadius und NebenRadius überschritten.

Anfang

Erstellen eines Torus

Verwende makeTorus(radius1, radius2, [pnt, dir, Winkel1, Winkel2, Winkel]). Standardmäßig ist pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = 0, Winkel2 = 360 und Winkel = 360. Betrachte einen Torus als kleinen Kreis, der entlang eines großen Kreises verläuft. Radius1 ist der Radius des großen Kreises, Radius2 ist der Radius des kleinen Kreises, pnt ist der Mittelpunkt des Torus und dir ist die Normalenrichtung. winkel1 und winkel2 sind Winkel in Grad für den kleinen Kreis; der letzte Winkelparameter besteht darin, einen Schnitt von den Torus:

torus = Part.makeTorus(10, 2)

Der obige Code erzeugt einen Torus mit Durchmesser 20 (Radius 10) und Dicke 4 (kleiner Kreisradius 2)

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 180)

Der obige Code erzeugt eine Scheibe des Torus.

tor=Part.makeTorus(10, 5, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), 0, 360, 180)

Der obige Code erzeugt einen Halbtorus; nur der letzte Parameter wird geändert. d.h. die restlichen Winkel sind Standardwerte. Die Angabe des Winkels 180 bewirkt den Torus von 0 bis 180, d.h. einen halben Torus, erzeugen.

Anfang

Kasten oder Quader erstellen

Verwendung von makeBox(Länge, Breite, Höhe, [pnt, dir]). Standardmäßig werden pnt = Vektor(0, 0, 0) und dir = Vektor(0, 0, 1) verwendet.

box = Part.makeBox(10, 10, 10)
len(box.Vertexes)
> 8

Anfang

Erstelle eine Kugel

Mit makeSphere(radius, [pnt, dir, winkel1, winkel2, winkel3]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1), Winkel1 = -90, Winkel2 = 90 und Winkel3 = 360. Winkel1 und Winkel2 sind das vertikale Minimum und Maximum der Kugel, Winkel3 ist der Kugeldurchmesser.

sphere = Part.makeSphere(10)
hemisphere = Part.makeSphere(10, Base.Vector(0, 0, 0), Base.Vector(0, 0, 1), -90, 90, 180)

Anfang

Erstellen eines Zylinders

Verwende makeCylinder(Radius, Höhe, [pnt, dir, Winkel]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.

cylinder = Part.makeCylinder(5, 20)
partCylinder = Part.makeCylinder(5, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

Anfang

Erstellen eines Kegels

Verwendung makeCone(radius1, radius2, höhe, [pnt, dir, winkel]). Standardmäßig pnt = Vektor(0, 0, 0), dir = Vektor(0, 0, 1) und Winkel = 360.

cone = Part.makeCone(10, 0, 20)
semicone = Part.makeCone(10, 0, 20, Base.Vector(20, 0, 0), Base.Vector(0, 0, 1), 180)

Anfang

Formen ändern

Es gibt verschiedene Möglichkeiten, Formen zu ändern. Einige sind einfache Transformationsoperationen wie sich bewegende oder rotierende Formen, andere sind komplexer, wie die Vereinigung und Subtrahieren einer Form von einer anderen.

Anfang

Umwandlungsvorgänge

Übersetzen einer Form

Übersetzen ist die Handlung, eine Form von einem Ort zum anderen zu bewegen. Jede Form (Kante, Fläche, Würfel, usw...) kann auf die gleiche Weise übersetzt werden:

myShape = Part.makeBox(2, 2, 2)
myShape.translate(Base.Vector(2, 0, 0))

Dadurch wird unsere Form "myShape" um 2 Einheiten in die X Richtung verschoben.

Anfang

Drehen einer Form

Um eine Form zu drehen, musst du das Rotationszentrum, die Achse, angeben, und den Rotationswinkel:

myShape.rotate(Base.Vector(0, 0, 0),Base.Vector(0, 0, 1), 180)

Der obige Code dreht die Form um 180 Grad um die Z Achse.

Anfang

Matrix Umformungen

Eine Matrix ist eine sehr bequeme Möglichkeit, Transformationen in der 3D Welt. In einer einzigen Matrix kannst du Translation, Rotation und Skalierung einstellen Werte, die auf ein Objekt angewendet werden sollen. Zum Beispiel:

myMat = Base.Matrix()
myMat.move(Base.Vector(2, 0, 0))
myMat.rotateZ(math.pi/2)

Hinweis: FreeCAD Matrizen arbeiten im Bogenmaß. Außerdem werden fast alle Matrix Operationen die einen Vektor nehmen, können auch drei Zahlen nehmen, so dass diese beiden Linien dasselbe tun:

myMat.move(2, 0, 0)
myMat.move(Base.Vector(2, 0, 0))

Wenn unsere Matrix einmal festgelegt ist, können wir sie auf unsere Form anwenden. FreeCAD bietet zwei Methoden, um das zu tun: transformShape() und transformGeometry(). Der Unterschied ist, dass Sie bei der ersten sicher sind, dass keine Verformungen auftreten werden (siehe Skalierung einer Form unten). Wir können unsere Transformation wie folgt anwenden:

myShape.transformShape(myMat)

oder

myShape.transformGeometry(myMat)

Anfang

Skalieren einer Form

Das Skalieren einer Form ist eine gefährlichere Operation, denn im Gegensatz zur Übersetzung oder Rotation, ungleichmäßige Skalierung (mit unterschiedlichen Werten für X, Y und Z) kann die Struktur der Form verändern. Beispielsweise kann die Skalierung eines Kreises mit ein höherer Wert horizontal als vertikal wandelt ihn in einen Ellipse, die sich mathematisch sehr unterschiedlich verhält. Für die Skalierung haben wir nicht die transformShape() verwenden können, müssen wir transformGeometry() verwenden:

myMat = Base.Matrix()
myMat.scale(2, 1, 1)
myShape=myShape.transformGeometry(myMat)

Anfang

Boolesche Operationen

Subtraktion

Das Subtrahieren einer Form von einer anderen Form wird in FreeCAD "Schnitt" genannt und wird so gemacht:

cylinder = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
sphere = Part.makeSphere(5, Base.Vector(5, 0, 0))
diff = cylinder.cut(sphere)

Anfang

Überschneidung

Auf die gleiche Weise wird die Überschneidung zwischen zwei Formen als "gemeinsam" bezeichnet und auf diese Weise gemacht:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
common = cylinder1.common(cylinder2)

Anfang

Vereinigen

Vereinigen wird "Verschmelzen" genannt und funktioniert auf dieselbe Weise:

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
fuse = cylinder1.fuse(cylinder2)

Anfang

Abschnitt

Ein "Abschnitt" ist der Kreuzungspunkt zwischen einer festen Form und einer ebenen Form. Er gibt eine Kreuzungskurve, eine Verbundkurve, die aus Kanten besteht zurück.

cylinder1 = Part.makeCylinder(3, 10, Base.Vector(0, 0, 0), Base.Vector(1, 0, 0))
cylinder2 = Part.makeCylinder(3, 10, Base.Vector(5, 0, -5), Base.Vector(0, 0, 1))
section = cylinder1.section(cylinder2)
section.Wires
> []
section.Edges
> [<Edge object at 0D87CFE8>, <Edge object at 019564F8>, <Edge object at 0D998458>, 
 <Edge  object at 0D86DE18>, <Edge object at 0D9B8E80>, <Edge object at 012A3640>, 
 <Edge object at 0D8F4BB0>]

Anfang

Extrusion

Extrusion ist der Vorgang des "Drückens" einer flachen Form in eine bestimmte Richtung, was zu einem festen Körper führt. Stell dir vor, dass ein Kreis durch "Herausschieben" zu einer Röhre wird:

circle = Part.makeCircle(10)
tube = circle.extrude(Base.Vector(0, 0, 2))

Wenn dein Kreis hohl ist, erhälst du ein hohles Rohr. Wenn dein Kreis tatsächlich eine Scheibe mit einer gefüllten Fläche ist, erhälst du einen massiven Zylinder:

wire = Part.Wire(circle)
disc = Part.Face(wire)
cylinder = disc.extrude(Base.Vector(0, 0, 2))

Anfang

Formen untersuchen

Du kannst die topologische Datenstruktur leicht erkunden:

import Part
b = Part.makeBox(100, 100, 100)
b.Wires
w = b.Wires[0]
w
w.Wires
w.Vertexes
Part.show(w)
w.Edges
e = w.Edges[0]
e.Vertexes
v = e.Vertexes[0]
v.Point

Durch tippen der obigen Zeilen in den Python Interpreter, erhälst du eine gutes Verständnis der Struktur von Teilobjekten. Hier hat unser makeBox() Befehl eine feste Form geschaffen. Dieser Volumenkörper enthält, wie alle Teil Volumenkörper, Flächen. Flächen enthalten immer Drähte, d.h. Listen von Kanten, die die Fläche begrenzen. Jede Fläche hat mindestens einen geschlossenen Draht (sie kann mehr haben, wenn die Fläche ein Loch hat). In dem Draht können wir jede Kante einzeln betrachten, und innerhalb jeder Kante können wir siehe die Eckpunkte. Gerade Kanten haben offensichtlich nur zwei Knoten.

Anfang

Kantenanalyse

Im Falle einer Kante, die eine willkürliche Kurve ist, ist es am wahrscheinlichsten, dass du eine Diskretisierung durchführen möchtest. In FreeCAD werden die Kanten durch ihre Länge parametrisiert. Das bedeutet, dass du eine Kante/Kurve anhand ihrer Länge entlang laufen kannst:

import Part
box = Part.makeBox(100, 100, 100)
anEdge = box.Edges[0]
print(anEdge.Length)

Jetzt kannst du auf viele Eigenschaften der Kante zugreifen, indem du die Länge als Position verwendest. Das heißt, wenn die Kante 100 mm lang ist, ist die Startposition 0 und die Endposition 100.

anEdge.tangentAt(0.0)          # tangent direction at the beginning
anEdge.valueAt(0.0)            # Point at the beginning
anEdge.valueAt(100.0)          # Point at the end of the edge
anEdge.derivative1At(50.0)     # first derivative of the curve in the middle
anEdge.derivative2At(50.0)     # second derivative of the curve in the middle
anEdge.derivative3At(50.0)     # third derivative of the curve in the middle
anEdge.centerOfCurvatureAt(50) # center of the curvature for that position
anEdge.curvatureAt(50.0)       # the curvature
anEdge.normalAt(50)            # normal vector at that position (if defined)

Anfang

Verwendung einer Auswahl

Hier sehen wir nun, wie wir eine Auswahl verwenden können, die der Benutzer im Betrachter getroffen hat. Zuerst erstellen wir einen Kasten und zeigen ihn im Betrachter an.

import Part
Part.show(Part.makeBox(100, 100, 100))
Gui.SendMsgToActiveView("ViewFit")

Wähle nun einige Flächen oder Kanten aus. Mit diesem Skript kannst du über alle ausgewählten Objekte und deren Unterelemente iterieren:

for o in Gui.Selection.getSelectionEx():
    print(o.ObjectName)
    for s in o.SubElementNames:
        print("name: ", s)
        for s in o.SubObjects:
            print("object: ", s)

Wähle einige Kanten aus und dieses Skript berechnet die Länge:

length = 0.0
for o in Gui.Selection.getSelectionEx():
    for s in o.SubObjects:
        length += s.Length

print("Length of the selected edges: ", length)

Anfang

Beispiel: Die OCC Flasche

Ein typisches Beispiel, das auf der OpenCasCade Technology Website zu finden ist, ist der Bau einer Flasche. Dies ist auch eine gute Übung für FreeCAD. Wenn du unserem Beispiel unten und der OCC-Seite gleichzeitig folgst, wirst du sehen, wie gut OCC Strukturen in FreeCAD implementiert sind. Das Skript ist in der FreeCAD Installation enthalten (innerhalb des Ordners Mod/Part) und kann vom Python Interpreter durch Eintippen aufgerufen werden:

import Part
import MakeBottle
bottle = MakeBottle.makeBottle()
Part.show(bottle)

Anfang

Das Skript=

Für die Zwecke dieses Tutoriums werden wir eine reduzierte Version des Skripts in Betracht ziehen. In dieser Version wird die Flasche nicht ausgehöhlt, und der Flaschenhals wird nicht mit einem Gewinde versehen.

import Part, math
from FreeCAD import Base

def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
    aPnt5=Base.Vector(myWidth / 2., 0, 0)

    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
    aSegment2=Part.LineSegment(aPnt4, aPnt5)

    aEdge1=aSegment1.toShape()
    aEdge2=aArcOfCircle.toShape()
    aEdge3=aSegment2.toShape()
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])

    aTrsf=Base.Matrix()
    aTrsf.rotateZ(math.pi) # rotate around the z-axis

    aMirroredWire=aWire.copy()
    aMirroredWire.transformShape(aTrsf)
    myWireProfile=Part.Wire([aWire, aMirroredWire])

    myFaceProfile=Part.Face(myWireProfile)
    aPrismVec=Base.Vector(0, 0, myHeight)
    myBody=myFaceProfile.extrude(aPrismVec)

    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)

    neckLocation=Base.Vector(0, 0, myHeight)
    neckNormal=Base.Vector(0, 0, 1)

    myNeckRadius = myThickness / 4.
    myNeckHeight = myHeight / 10.
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)
    myBody = myBody.fuse(myNeck)

    return myBody

el = makeBottleTut()
Part.show(el)

Anfang

Detaillierte Erklärung

import Part, math
from FreeCAD import Base

Wir benötigen natürlich das Modul Part, aber auch das Modul FreeCAD.Base, das grundlegende FreeCAD Strukturen wie Vektoren und Matrizen enthält.

def makeBottleTut(myWidth = 50.0, myHeight = 70.0, myThickness = 30.0):
    aPnt1=Base.Vector(-myWidth / 2., 0, 0)
    aPnt2=Base.Vector(-myWidth / 2., -myThickness / 4., 0)
    aPnt3=Base.Vector(0, -myThickness / 2., 0)
    aPnt4=Base.Vector(myWidth / 2., -myThickness / 4., 0)
    aPnt5=Base.Vector(myWidth / 2., 0, 0)

Hier definieren wir unsere makeBottleTut Funktion. Diese Funktion kann aufgerufen werden ohne Argumente, wie wir es oben getan haben, in diesem Fall Standardwerte für Breite und Höhe, und Dicke verwendet werden. Dann definieren wir ein paar Punkte, die verwendet werden für den Aufbau unseres Basisprofils.

...
    aArcOfCircle = Part.Arc(aPnt2, aPnt3, aPnt4)
    aSegment1=Part.LineSegment(aPnt1, aPnt2)
    aSegment2=Part.LineSegment(aPnt4, aPnt5)

Hier definieren wir die Geometrie: einen Bogen, der aus drei Punkten besteht, und zwei Liniensegmente, die aus zwei Punkten bestehen.

...
    aEdge1=aSegment1.toShape()
    aEdge2=aArcOfCircle.toShape()
    aEdge3=aSegment2.toShape()
    aWire=Part.Wire([aEdge1, aEdge2, aEdge3])

Erinnerst du dich an den Unterschied zwischen Geometrie und Formen? Hier bauen wir Formen aus unserer Konstruktionsgeometrie. Drei Kanten (Kanten können gerade sein oder gebogen), dann einen Draht hergestellt aus diesen drei Kanten.

...
    aTrsf=Base.Matrix()
    aTrsf.rotateZ(math.pi) # rotate around the z-axis

    aMirroredWire=aWire.copy()
    aMirroredWire.transformShape(aTrsf)
    myWireProfile=Part.Wire([aWire, aMirroredWire])

Bislang haben wir nur ein halbes Profil erstellt. Anstatt das ganze Profil zu bauen Auf die gleiche Weise können wir einfach spiegeln, was wir getan haben, und beide Hälften zusammenkleben. Zuerst erstellen wir eine Matrix. Eine Matrix ist ein sehr gebräuchlicher Weg, um Transformationen auf Objekte in der 3D Welt anzuwenden, da sie in einer Struktur alle grundlegenden Transformationen, denen 3D Objekte unterzogen werden können (Verschieben, Drehen und Skalieren) enthalten. Nachdem wir die Matrix erstellt haben, spiegeln wir sie, dann erstellen wir eine Kopie unseres Drahtes und wenden die Transformationsmatrix darauf an. Wir haben jetzt zwei Drähte, und können wir einen dritten Draht aus ihnen machen, da Drähte eigentlich Listen von Kanten sind.

...
    myFaceProfile=Part.Face(myWireProfile)
    aPrismVec=Base.Vector(0, 0, myHeight)
    myBody=myFaceProfile.extrude(aPrismVec)

    myBody=myBody.makeFillet(myThickness / 12.0, myBody.Edges)

Nun, da wir einen geschlossenen Draht haben, kann er in eine Fläche verwandelt werden. Sobald wir eine Fläche haben, können wir es extrudieren. Auf diese Weise machen wir einen Festkörper. Dann wenden wir eine schöne kleine Verrundung auf unser Objekt an, weil wir uns um gutes Design kümmern, nicht wahr?

...
    neckLocation=Base.Vector(0, 0, myHeight)
    neckNormal=Base.Vector(0, 0, 1)

    myNeckRadius = myThickness / 4.
    myNeckHeight = myHeight / 10.
    myNeck = Part.makeCylinder(myNeckRadius, myNeckHeight, neckLocation, neckNormal)

An diesem Punkt ist der Körper unserer Flasche hergestellt, aber wir müssen noch einen Hals schaffen. Wir stellen einen neuen Körper mit einem Zylinder her.

...
    myBody = myBody.fuse(myNeck)

Der Verschmelzungsoperation ist sehr leistungsstark. Sie kümmert sich um das Kleben, was geklebt werden muss, und entfernt Teile, die entfernt werden müssen.

...
    return myBody

Dann geben wir als Ergebnis unserer Funktion unseren Part Volumenkörper zurück.

el = makeBottleTut()
Part.show(el)

Schließlich rufen wir die Funktion auf, um das Teil tatsächlich zu erstellen und es dann sichtbar zu machen.

Anfang

Beispiel: Durchbohrter Quader

Hier ist ein vollständiges Beispiel für den Bau eines durchbohrten Quaders.

Der Aufbau erfolgt von einer Seite nach der anderen. Wenn der Würfel fertig ist, wird er durch das Durchschneiden eines Zylinders ausgehöhlt.

import Part, math
from FreeCAD import Base

size = 10
poly = Part.makePolygon([(0, 0, 0), (size, 0, 0), (size, 0, size), (0, 0, size), (0, 0, 0)])

face1 = Part.Face(poly)
face2 = Part.Face(poly)
face3 = Part.Face(poly)
face4 = Part.Face(poly)
face5 = Part.Face(poly)
face6 = Part.Face(poly)
     
myMat = Base.Matrix()

myMat.rotateZ(math.pi / 2)
face2.transformShape(myMat)
face2.translate(Base.Vector(size, 0, 0))

myMat.rotateZ(math.pi / 2)
face3.transformShape(myMat)
face3.translate(Base.Vector(size, size, 0))

myMat.rotateZ(math.pi / 2)
face4.transformShape(myMat)
face4.translate(Base.Vector(0, size, 0))

myMat = Base.Matrix()

myMat.rotateX(-math.pi / 2)
face5.transformShape(myMat)

face6.transformShape(myMat)               
face6.translate(Base.Vector(0, 0, size))

myShell = Part.makeShell([face1, face2, face3, face4, face5, face6])   
mySolid = Part.makeSolid(myShell)

myCyl = Part.makeCylinder(2, 20)
myCyl.translate(Base.Vector(size / 2, size / 2, 0))

cut_part = mySolid.cut(myCyl)

Part.show(cut_part)

Anfang

Laden und Speichern

Es gibt mehrere Möglichkeiten, deine Arbeit zu speichern. Du kannst natürlich dein FreeCAD Dokument speichern, aber Du kannst auch Part Objekte direkt in gängigen CAD Formaten wie BREP, IGS, STEP und STL speichern.

Das Speichern einer Form in einer Datei ist einfach. Es stehen die Methoden exportBrep(), exportIges(), exportStep() und exportStl() für alle Formobjekte zur Verfügung. Also, ausführen:

import Part
s = Part.makeBox(10, 10, 10)
s.exportStep("test.stp")

wird unseren Quader in eine STEP Datei gespeichert. Um eine BREP , IGES oder STEP Datei zu laden:

import Part
s = Part.Shape()
s.read("test.stp")

Um eine STEP Datei in eine IGS Datei umzuwandeln:

import Part
 s = Part.Shape()
 s.read("file.stp")       # incoming file igs, stp, stl, brep
 s.exportIges("file.igs") # outbound file igs

Anfang